package com.gyee.frame.model.auto;

import java.util.ArrayList;
import java.util.List;

public class TvuePermissionExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<TvuePermissionExample.Criteria> oredCriteria;

    public TvuePermissionExample() {
        oredCriteria = new ArrayList<TvuePermissionExample.Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<TvuePermissionExample.Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(TvuePermissionExample.Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public TvuePermissionExample.Criteria or() {
        TvuePermissionExample.Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public TvuePermissionExample.Criteria createCriteria() {
        TvuePermissionExample.Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected TvuePermissionExample.Criteria createCriteriaInternal() {
        TvuePermissionExample.Criteria criteria = new TvuePermissionExample.Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<TvuePermissionExample.Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<TvuePermissionExample.Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<TvuePermissionExample.Criterion> getAllCriteria() {
            return criteria;
        }

        public List<TvuePermissionExample.Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new TvuePermissionExample.Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new TvuePermissionExample.Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new TvuePermissionExample.Criterion(condition, value1, value2));
        }

        public TvuePermissionExample.Criteria andIdIsNull() {
            addCriterion("id is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameIsNull() {
            addCriterion("name is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameIsNotNull() {
            addCriterion("name is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameEqualTo(String value) {
            addCriterion("name =", value, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameNotEqualTo(String value) {
            addCriterion("name <>", value, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameGreaterThan(String value) {
            addCriterion("name >", value, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameGreaterThanOrEqualTo(String value) {
            addCriterion("name >=", value, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameLessThan(String value) {
            addCriterion("name <", value, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameLessThanOrEqualTo(String value) {
            addCriterion("name <=", value, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameLike(String value) {
            addCriterion("name like", value, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameNotLike(String value) {
            addCriterion("name not like", value, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameIn(List<String> values) {
            addCriterion("name in", values, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameNotIn(List<String> values) {
            addCriterion("name not in", values, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameBetween(String value1, String value2) {
            addCriterion("name between", value1, value2, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andNameNotBetween(String value1, String value2) {
            addCriterion("name not between", value1, value2, "name");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionIsNull() {
            addCriterion("descripion is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionIsNotNull() {
            addCriterion("descripion is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionEqualTo(String value) {
            addCriterion("descripion =", value, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionNotEqualTo(String value) {
            addCriterion("descripion <>", value, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionGreaterThan(String value) {
            addCriterion("descripion >", value, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionGreaterThanOrEqualTo(String value) {
            addCriterion("descripion >=", value, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionLessThan(String value) {
            addCriterion("descripion <", value, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionLessThanOrEqualTo(String value) {
            addCriterion("descripion <=", value, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionLike(String value) {
            addCriterion("descripion like", value, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionNotLike(String value) {
            addCriterion("descripion not like", value, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionIn(List<String> values) {
            addCriterion("descripion in", values, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionNotIn(List<String> values) {
            addCriterion("descripion not in", values, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionBetween(String value1, String value2) {
            addCriterion("descripion between", value1, value2, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andDescripionNotBetween(String value1, String value2) {
            addCriterion("descripion not between", value1, value2, "descripion");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlIsNull() {
            addCriterion("url is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlIsNotNull() {
            addCriterion("url is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlEqualTo(String value) {
            addCriterion("url =", value, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlNotEqualTo(String value) {
            addCriterion("url <>", value, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlGreaterThan(String value) {
            addCriterion("url >", value, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlGreaterThanOrEqualTo(String value) {
            addCriterion("url >=", value, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlLessThan(String value) {
            addCriterion("url <", value, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlLessThanOrEqualTo(String value) {
            addCriterion("url <=", value, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlLike(String value) {
            addCriterion("url like", value, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlNotLike(String value) {
            addCriterion("url not like", value, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlIn(List<String> values) {
            addCriterion("url in", values, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlNotIn(List<String> values) {
            addCriterion("url not in", values, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlBetween(String value1, String value2) {
            addCriterion("url between", value1, value2, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andUrlNotBetween(String value1, String value2) {
            addCriterion("url not between", value1, value2, "url");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankIsNull() {
            addCriterion("is_blank is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankIsNotNull() {
            addCriterion("is_blank is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankEqualTo(Integer value) {
            addCriterion("is_blank =", value, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankNotEqualTo(Integer value) {
            addCriterion("is_blank <>", value, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankGreaterThan(Integer value) {
            addCriterion("is_blank >", value, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_blank >=", value, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankLessThan(Integer value) {
            addCriterion("is_blank <", value, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankLessThanOrEqualTo(Integer value) {
            addCriterion("is_blank <=", value, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankIn(List<Integer> values) {
            addCriterion("is_blank in", values, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankNotIn(List<Integer> values) {
            addCriterion("is_blank not in", values, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankBetween(Integer value1, Integer value2) {
            addCriterion("is_blank between", value1, value2, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIsBlankNotBetween(Integer value1, Integer value2) {
            addCriterion("is_blank not between", value1, value2, "isBlank");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidIsNull() {
            addCriterion("pid is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidIsNotNull() {
            addCriterion("pid is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidEqualTo(String value) {
            addCriterion("pid =", value, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidNotEqualTo(String value) {
            addCriterion("pid <>", value, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidGreaterThan(String value) {
            addCriterion("pid >", value, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidGreaterThanOrEqualTo(String value) {
            addCriterion("pid >=", value, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidLessThan(String value) {
            addCriterion("pid <", value, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidLessThanOrEqualTo(String value) {
            addCriterion("pid <=", value, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidLike(String value) {
            addCriterion("pid like", value, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidNotLike(String value) {
            addCriterion("pid not like", value, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidIn(List<String> values) {
            addCriterion("pid in", values, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidNotIn(List<String> values) {
            addCriterion("pid not in", values, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidBetween(String value1, String value2) {
            addCriterion("pid between", value1, value2, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPidNotBetween(String value1, String value2) {
            addCriterion("pid not between", value1, value2, "pid");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsIsNull() {
            addCriterion("perms is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsIsNotNull() {
            addCriterion("perms is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsEqualTo(String value) {
            addCriterion("perms =", value, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsNotEqualTo(String value) {
            addCriterion("perms <>", value, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsGreaterThan(String value) {
            addCriterion("perms >", value, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsGreaterThanOrEqualTo(String value) {
            addCriterion("perms >=", value, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsLessThan(String value) {
            addCriterion("perms <", value, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsLessThanOrEqualTo(String value) {
            addCriterion("perms <=", value, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsLike(String value) {
            addCriterion("perms like", value, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsNotLike(String value) {
            addCriterion("perms not like", value, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsIn(List<String> values) {
            addCriterion("perms in", values, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsNotIn(List<String> values) {
            addCriterion("perms not in", values, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsBetween(String value1, String value2) {
            addCriterion("perms between", value1, value2, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andPermsNotBetween(String value1, String value2) {
            addCriterion("perms not between", value1, value2, "perms");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeIsNull() {
            addCriterion("type is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeIsNotNull() {
            addCriterion("type is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeEqualTo(Integer value) {
            addCriterion("type =", value, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeNotEqualTo(Integer value) {
            addCriterion("type <>", value, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeGreaterThan(Integer value) {
            addCriterion("type >", value, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("type >=", value, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeLessThan(Integer value) {
            addCriterion("type <", value, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeLessThanOrEqualTo(Integer value) {
            addCriterion("type <=", value, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeIn(List<Integer> values) {
            addCriterion("type in", values, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeNotIn(List<Integer> values) {
            addCriterion("type not in", values, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeBetween(Integer value1, Integer value2) {
            addCriterion("type between", value1, value2, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("type not between", value1, value2, "type");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconIsNull() {
            addCriterion("icon is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconIsNotNull() {
            addCriterion("icon is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconEqualTo(String value) {
            addCriterion("icon =", value, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconNotEqualTo(String value) {
            addCriterion("icon <>", value, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconGreaterThan(String value) {
            addCriterion("icon >", value, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconGreaterThanOrEqualTo(String value) {
            addCriterion("icon >=", value, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconLessThan(String value) {
            addCriterion("icon <", value, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconLessThanOrEqualTo(String value) {
            addCriterion("icon <=", value, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconLike(String value) {
            addCriterion("icon like", value, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconNotLike(String value) {
            addCriterion("icon not like", value, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconIn(List<String> values) {
            addCriterion("icon in", values, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconNotIn(List<String> values) {
            addCriterion("icon not in", values, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconBetween(String value1, String value2) {
            addCriterion("icon between", value1, value2, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andIconNotBetween(String value1, String value2) {
            addCriterion("icon not between", value1, value2, "icon");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumIsNull() {
            addCriterion("order_num is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumIsNotNull() {
            addCriterion("order_num is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumEqualTo(Integer value) {
            addCriterion("order_num =", value, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumNotEqualTo(Integer value) {
            addCriterion("order_num <>", value, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumGreaterThan(Integer value) {
            addCriterion("order_num >", value, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("order_num >=", value, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumLessThan(Integer value) {
            addCriterion("order_num <", value, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumLessThanOrEqualTo(Integer value) {
            addCriterion("order_num <=", value, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumIn(List<Integer> values) {
            addCriterion("order_num in", values, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumNotIn(List<Integer> values) {
            addCriterion("order_num not in", values, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumBetween(Integer value1, Integer value2) {
            addCriterion("order_num between", value1, value2, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andOrderNumNotBetween(Integer value1, Integer value2) {
            addCriterion("order_num not between", value1, value2, "orderNum");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleIsNull() {
            addCriterion("visible is null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleIsNotNull() {
            addCriterion("visible is not null");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleEqualTo(Integer value) {
            addCriterion("visible =", value, "visible");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleNotEqualTo(Integer value) {
            addCriterion("visible <>", value, "visible");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleGreaterThan(Integer value) {
            addCriterion("visible >", value, "visible");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleGreaterThanOrEqualTo(Integer value) {
            addCriterion("visible >=", value, "visible");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleLessThan(Integer value) {
            addCriterion("visible <", value, "visible");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleLessThanOrEqualTo(Integer value) {
            addCriterion("visible <=", value, "visible");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleIn(List<Integer> values) {
            addCriterion("visible in", values, "visible");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleNotIn(List<Integer> values) {
            addCriterion("visible not in", values, "visible");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleBetween(Integer value1, Integer value2) {
            addCriterion("visible between", value1, value2, "visible");
            return (TvuePermissionExample.Criteria) this;
        }

        public TvuePermissionExample.Criteria andVisibleNotBetween(Integer value1, Integer value2) {
            addCriterion("visible not between", value1, value2, "visible");
            return (TvuePermissionExample.Criteria) this;
        }
    }

    public static class Criteria extends TvuePermissionExample.GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}